// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC.ui;

import JRunMC.util.*;

// Imports
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.*;
import java.math.*;
import java.lang.*;

class EditorHisto 
                extends         JFrame
 {


    public static final long serialVersionUID = 8;

    public static int  Nvariable=0;     // current number of variables 
//    public Vector  listData;    // with variables                              
    public static Vector<Object>  HVariables;  // with variables   
    public static Vector<Object>  HComments;   // with variables   

// to keep objects which have been copied  
    private static Vector<Object>  H1;
    private static Vector<Object>  H2;
    private static Vector<Object>  H3;
    private static Vector<Object>  H4;
    private static Vector<Object>  H5;
    private static Vector<Object>  H6;
    private static Vector<Object>  H7;
    private static int PointerRow=0;

// to keep all elements 
    private static Vector<Object>  H1a;
    private static Vector<Object>  H2a;
    private static Vector<Object>  H3a;
    private static Vector<Object>  H4a;
    private static Vector<Object>  H5a;
    private static Vector<Object>  H6a;
    private static Vector<Object>  H7a;

 

    public static  int Hcurrent=0; // current position in table when inset
    public static DefaultListModel variableModel;
    private JPanel contentPane;
    private JPanel jPanel1;

    private static JPopupMenu menu;
    private static JComboBox jHC0;
    private static JButton jHB1;
    private static JButton jHB2;
    private static FlowLayout flowLayout1;
    private static JSplitPane jSplitPane1;
    private static JScrollPane jScrollPane1;
    private static JScrollPane jScrollPane2;
    public  static JTableSource  jHlist; // variables 
    public  static JTableTarget  jHTab1; // histograms  

    public  static DefaultListModel HlistModel;
    private BorderLayout borderLayout1;
    private static MyTableModel model;
    public static  MyTableModelInfo  model0; 
           
        // Instance attributes used in this dialog
        public EditorHisto()  {

         setDefaultCloseOperation( DISPOSE_ON_CLOSE ); 
         jPanel1 = new JPanel();
         jHB1 = new JButton();
         jHB2 = new JButton();
         flowLayout1 = new FlowLayout();
         jSplitPane1 = new JSplitPane();
         jScrollPane1 = new JScrollPane();
         jScrollPane2 = new JScrollPane();
         borderLayout1 = new BorderLayout();
        
         H1 =  new Vector<Object>();
          H2 =  new Vector<Object>(); 
            H3 =  new Vector<Object>();
              H4 =  new Vector<Object>();
                 H5 =  new Vector<Object>();
                   H6 =  new Vector<Object>();
                     H7 =  new Vector<Object>();

        H1a =  new Vector<Object>();
          H2a =  new Vector<Object>();
            H3a =  new Vector<Object>();
              H4a =  new Vector<Object>();
                 H5a =  new Vector<Object>();
                   H6a =  new Vector<Object>();
                     H7a =  new Vector<Object>();

                  
        contentPane = (JPanel)getContentPane();
        setDefaultCloseOperation( DISPOSE_ON_CLOSE );
        setTitle( "Variables and Histogram editor");
        contentPane.setLayout(borderLayout1);
        setSize(new Dimension(820, 340));
        contentPane.setPreferredSize(new Dimension(800, 335));
        jPanel1.setLayout(flowLayout1);
        jPanel1.setPreferredSize(new Dimension(800, 35));
        jPanel1.setToolTipText("");
        jHB1.setText("Save");
// save histograms in Histogram editor
        jHB1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Save Settings?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
          if (ask == JOptionPane.YES_OPTION) {
                    // System.out.print("Something is wrong");
                    boolean doCheck=true; // save with checking
                    SaveHistograms(doCheck);
                    setMessage(); 
                    SetIni.ShowStatus="Last action: histograms saved";
          }
         }  });

 
        
         
    // Create the data model for this example
    variableModel = new DefaultListModel();
    HVariables = new Vector<Object>();
    HComments = new Vector<Object>();


       model0 = new MyTableModelInfo();
       jHlist = new JTableSource() { 

             public static final long serialVersionUID = 127;

             public Component prepareRenderer(TableCellRenderer renderer,
                                              int rowIndex, int vColIndex) {
            Component c = super.prepareRenderer(renderer, rowIndex, vColIndex);

            Color colcell = new  Color(244, 255, 255);
            Color colcolu = new  Color(255, 255, 200);


            if (rowIndex % 2 == 0 && !isCellSelected(rowIndex, vColIndex)) {
                c.setBackground(colcell);
            } else {
                // If not shaded, match the table's background
                c.setBackground(getBackground());
            }

          if (vColIndex ==0) c.setBackground(colcolu);
          // colom 
          c.setForeground(Color.black);       
          if (isCellSelected(rowIndex, vColIndex))  {c.setBackground(Color.blue); 
                                                     c.setForeground(Color.white);} 
            return c;
        }
    };

       jHlist.setModel(model0); 
       JTableHeader anHeader = jHlist.getTableHeader();
       anHeader.setForeground(new Color(0).yellow);
       anHeader.setBackground(new Color(0).black);



       jHlist.setRowHeight(24);
       jHlist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
       jHlist.setShowGrid(false);
       model0.addColumn("Variable");
       model0.addColumn("Comment");
       jHlist.setFont(SetEnv.FontBold);


       jHlist.setShowHorizontalLines( true );
       jHlist.setShowVerticalLines( false );
       jHlist.setRowSelectionAllowed( true );
       jHlist.setColumnSelectionAllowed( false );

       // channge size
          TableColumn column0 = null;
          column0 = jHlist.getColumnModel().getColumn(0);
          column0.setPreferredWidth(80);
          column0.setMinWidth(20);
          column0.setMaxWidth(200);
          column0 = jHlist.getColumnModel().getColumn(1);
          column0.setPreferredWidth(100);
          column0.setMinWidth(60);
          column0.setMaxWidth(400);




 // histogram table  
       jHTab1 = new JTableTarget()
      {
             public static final long serialVersionUID = 128;
             public Component prepareRenderer(TableCellRenderer renderer,
                                              int rowIndex, int vColIndex) {
            Component c = super.prepareRenderer(renderer, rowIndex, vColIndex);

            Color colcell = new  Color(255, 250, 240);
            Color colsell = new  Color(230, 230, 255);
            Color colselcel = new  Color(255, 244, 130);

            if (rowIndex % 2 == 0 && !isCellSelected(rowIndex, vColIndex)) {
                c.setBackground(colcell);
            } else {
                // If not shaded, match the table's background
                c.setBackground(getBackground());
            }

             if( jHTab1.isRowSelected( rowIndex ) ){
                //    c.setBackground(colsell);
                       c.setBackground(colselcel);
              }



            return c;
        }
    }; 

       model = new MyTableModel();
       jHTab1.setModel(model); 
       jHTab1.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
       model.addColumn("No");
       model.addColumn("Title");
       model.addColumn("D");
       model.addColumn("Min");
       model.addColumn("Max");
       model.addColumn("Bins");
       model.addColumn("W");
       model.addColumn("Comments");


     // pop-up menu for table 
     menu = new JPopupMenu();
    JMenuItem icut = new JMenuItem("Cut");
    JMenuItem icopy = new JMenuItem("Copy");
    JMenuItem ipaste = new JMenuItem("Paste");
    menu.add(icut);
    menu.add(icopy);
    menu.add(ipaste);

    // Set the component to show the popup menu
    jHTab1.addMouseListener(new MouseAdapter() {

        public void mouseClicked(MouseEvent evt)
        {
            Point p = evt.getPoint();
            PointerRow  = jHTab1.rowAtPoint(p);
        //    System.out.println("Raw="+PointerRow);

        }
        public void mousePressed(MouseEvent evt) {
            if (evt.isPopupTrigger()) {
                menu.show(evt.getComponent(), evt.getX(), evt.getY());
            }
        }
        public void mouseReleased(MouseEvent evt) {
            if (evt.isPopupTrigger()) {
                menu.show(evt.getComponent(), evt.getX(), evt.getY());
            }
        }
    });
 

// cut  
    icut.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
            removeSelected();
            jScrollPane2.revalidate();
            jScrollPane2.repaint();
     }  });

// copy 
    icopy.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
            copySelected();
            jScrollPane2.revalidate();
            jScrollPane2.repaint();
     }  });

// paster 
    ipaste.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
            pasteSelected();
            jScrollPane2.revalidate();
            jScrollPane2.repaint();
     }  });




// menu bar
         JMenuBar jMenuBar1 = new JMenuBar();
         JMenu jMenuExit = new JMenu();
         JMenu jMenuOpt = new JMenu();
         JMenuItem jExit1 = new JMenuItem();
         JMenuItem jMenuFonts = new JMenuItem();
         JMenuItem jMenuBack = new JMenuItem();
         JMenuItem jMenuForg = new JMenuItem();
         jMenuExit.setText("File");
         jExit1.setText("Exit");
         jMenuOpt.setText("Options");
         jMenuFonts.setText("Fonts");
         jMenuBack.setText("Background color");
         jMenuForg.setText("Foreground color");
         jMenuBar1.add(jMenuExit);
         jMenuBar1.add(jMenuOpt);
         jMenuOpt.add(jMenuBack);
         jMenuOpt.add(jMenuForg);
         jMenuOpt.add(jMenuFonts);
         jMenuExit.add(jExit1);
         setJMenuBar(jMenuBar1);



      String[] items = {"user variables", "system variables"};
      jHC0 = new JComboBox(items);
    //  OP1.setBounds(120,10,180,25);
      jHC0.setSelectedIndex(0);
      jHC0.setFont(SetEnv.FontBold);
      jHC0.setPreferredSize(new java.awt.Dimension(200, 25));
      SetVariables(); // set user variables first

      jHC0.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            JComboBox combo = (JComboBox)e.getSource();
            int nn  = combo.getSelectedIndex();
                  if (nn ==0)  SetVariables(); // set user variables 
                  if (nn ==1)  SetSystemVariables();
       } } );



         // exit
         jExit1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, "Exit histogram editor?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) {
           SetIni.ShowStatus="Last action: Histogram editor is closed";
           setVisible(false); dispose();}
        }  });

    jMenuBack.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
    Color color = JColorChooser.showDialog(contentPane,"Background Color",jHTab1.getBackground());
    if (color != null) {
      jHTab1.setBackground(color);
    }
    //repaints menu after item is selected
    contentPane.repaint();
     }  });

    jMenuForg.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
    Color color = JColorChooser.showDialog(contentPane,"Foreground Color",jHTab1.getForeground());
    if (color != null) {
      jHTab1.setForeground(color);
    }
    //repaints menu after item is selected
    contentPane.repaint();
     }  });


// setting fonts
   jMenuFonts.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
   Font f = FontChooser.showDialog(EditorHisto.this,
                                    "Choose font",
                                    jHTab1.getFont());
    if (f != null) {
    jHTab1.setFont(f);
    }
    contentPane.repaint();
    }  });
        


        jHB2.setText("Exit");
        jHB2.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
          JOptionPane dialog1 = new JOptionPane();
          int ask=dialog1.showConfirmDialog(dialog1, 
          "Exit histogram editor?",
          "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
           if (ask == JOptionPane.YES_OPTION) {   
             SetIni.ShowStatus="Last action: Histogram editor is closed";
             setVisible(false); // dispose();
             }
        }  });

        

        
        // jT1.setText("");
        jSplitPane1.setOrientation(JSplitPane.HORIZONTAL_SPLIT);
        jSplitPane1.setOneTouchExpandable(true);
        jSplitPane1.setDividerLocation(300);
        
        
// channge size  
          TableColumn column = null;
          column = jHTab1.getColumnModel().getColumn(0);
          column.setPreferredWidth(50); 
          column.setMinWidth(15);
          column.setMaxWidth(70);
          column = jHTab1.getColumnModel().getColumn(1);
          column.setPreferredWidth(200);
          column.setMinWidth(80);
          column.setMaxWidth(400);
          column = jHTab1.getColumnModel().getColumn(2);
          column.setPreferredWidth(20);
          column.setMinWidth(15);
          column.setMaxWidth(35);
          column = jHTab1.getColumnModel().getColumn(3);
          column.setPreferredWidth(70);
          column.setMinWidth(40);
          column.setMaxWidth(100);
          column = jHTab1.getColumnModel().getColumn(4);
          column.setPreferredWidth(70);
          column.setMinWidth(40);
          column.setMaxWidth(100);          
          column = jHTab1.getColumnModel().getColumn(5);
          column.setPreferredWidth(60);
          column.setMinWidth(40);
          column.setMaxWidth(100);    
          column = jHTab1.getColumnModel().getColumn(6);
          column.setPreferredWidth(40); 
          column.setMinWidth(20);
          column.setMaxWidth(50);
          column = jHTab1.getColumnModel().getColumn(7);
          column.setPreferredWidth(300); 
          column.setMinWidth(100);
          column.setMaxWidth(800);
         jHTab1.getTableHeader().setToolTipText(
        "Specify dimension, Min, Max values, the bin width, weight for histograms");
   
         
        jHTab1.setMaximumSize(new Dimension(8000, 1000));
        jHTab1.setMinimumSize(new Dimension(100, 10));
        jHTab1.setFont(SetEnv.FontBold);
        jHTab1.setShowHorizontalLines( true );
        jHTab1.setRowSelectionAllowed( true );
        jHTab1.setColumnSelectionAllowed( true );
        jHTab1.setRowHeight(24);

   
        
        

        jPanel1.add(jHC0, null);
        jPanel1.add(jHB1, null);
        jPanel1.add(jHB2, null);
        jSplitPane1.add(jScrollPane1, JSplitPane.LEFT);
        jScrollPane1.getViewport().add(jHlist);
        jSplitPane1.add(jScrollPane2, JSplitPane.RIGHT);
        contentPane.add(jSplitPane1, java.awt.BorderLayout.CENTER);
        contentPane.add(jPanel1, java.awt.BorderLayout.SOUTH);
        jScrollPane2.getViewport().add(jHTab1);
        
     
	 
      jHlist.addMouseListener(new MouseAdapter()
      {
       public void mouseClicked(MouseEvent em)
        {

        if (em.getClickCount() == 1) {
            // jHTab1.addRowSelectionInterval(0,1);
            // jHTab1.addRowSelectionInterval(0,1);
          //  model.setRowCount(0);
          if (model.getRowCount() <= 0) { 
              model.addRow(new Object[]{new Integer(0),
                                    new String(" "),
                                    new Integer(0),
                                    new Double(0),
                                    new Double(0),
                                    new Integer(0),
                                    new Double(0),
                                    new String("Drag & Drop or double click on the left panel") });
           } 
         }

        if (em.getClickCount() == 2)
        {

            // first clean first dummy entry
            if (model.getRowCount() == 1) {
                     Object tmp=jHTab1.getValueAt(0,1);
                     String ss=tmp.toString();
                     if (ss.equals(" ")) model.setRowCount(0);
              }

            Point p = em.getPoint();
            int index  = jHlist.rowAtPoint(p);
            int column = jHlist.columnAtPoint(p); // This is the view column!
            // System.out.println("Raw="+row);
          Object tmp1=HVariables.elementAt(index);
          String s1=(String)tmp1;
          Object tmp2=HComments.elementAt(index);
          String s2=(String)tmp2;
          
          int hmax=jHTab1.getRowCount();
          int ncurrent=0;
           
          
          for (int i=0;i<hmax;i++) {
            Object tmp0=jHTab1.getValueAt(i, 1);
            if (tmp0 != null) ncurrent++;
          }
          
          // start with current value
          Hcurrent=ncurrent;
          
         // jHTab1.addRowSelectionInterval(0,1); 
          model.addRow(new Object[]{new Integer(Hcurrent+1),
                                    new String(s1), 
                                    new Integer(1),
                                    new Double(0.0),
                                    new Double(1.0),
                                    new Integer(10),  
                                    new Double(1),
                                    new String(" "+s2) }); 
          jHTab1.setRowHeight(20);
          Hcurrent++;
          // refrash
          jScrollPane2.revalidate();
          jScrollPane2.repaint(); 
  
      } } } );


	
	      
   }  // end main class 






          
// set variables from the file 
        public void SetVariables()  { 
         
          // clean first 
          HVariables.clear();
          HComments.clear();
          // Remove all rows
          model0.setRowCount(0);
          Nvariable=0;


          String path=SetEnv.RUNDIR;
          if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;

          try {
          FileReader inF = 
          new FileReader(path+File.separator+"proj"+File.separator+"user-name.txt");
          BufferedReader br = new BufferedReader(inF);
          String s; String s1; int icoma;   
          String[] sword; sword = new String[100];
          while (( s=br.readLine())!= null) { 
          s=StringUtil.replace(s, "\n", "");
          s=s.trim();
         
          if (!s.startsWith("#") && s.length()>1) {
          // make nice formatting
          // find first space
          icoma=s.indexOf(" ")+1;
          String var1=s.substring(0,icoma);
          String com1=s.substring(icoma,s.length());
          com1=com1.trim(); // trim
          var1=var1.trim();
          HVariables.addElement( var1 );
          HComments.addElement( com1 );
          Nvariable++;
          // System.out.println(s1);
          }
          }
          inF.close(); 
          }catch (IOException et) {System.out.println("Cannot find user-name.txt in proj directory!");}
         

         for (int i=0; i<HVariables.size();  i++) {
          String ss0=(String)HVariables.elementAt(i);
          String ss1=(String)HComments.elementAt(i);
            model0.addRow(
                   new Object[]{new String(ss0), new String(ss1) }); 
         } 
          jSplitPane1.repaint();     
        }  
         


    public void SetSystemVariables()  {

// clean first
          HVariables.clear();
          HComments.clear();
          model0.setRowCount(0);
          Nvariable=0;

          String path=SetEnv.RUNDIR;
          if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;


          try {
          FileReader inF =
          new FileReader(path+File.separator+"main"+File.separator+"sys"+File.separator+"system-histo.txt");
          BufferedReader br = new BufferedReader(inF);
          String s; String s1; int icoma;
          String[] sword; sword = new String[100];
          while (( s=br.readLine())!= null) {
          s=StringUtil.replace(s, "\n", "");
          s=s.trim();

          if (!s.startsWith("#") && s.length()>1) {
          // make nice formatting
          // find first space
          icoma=s.indexOf(" ")+1;
          String var1=s.substring(0,icoma);
          String com1=s.substring(icoma,s.length());
          com1=com1.trim(); // trim
          var1=var1.trim();
          HVariables.addElement( var1 );
          HComments.addElement( com1 );
          Nvariable++;
          // System.out.println(s1);
          }
          }
          inF.close();
          }catch (IOException et) {
          System.out.println("Cannot find system-histo.txt in main/sys directory!");}


          for (int i=0; i<HVariables.size();  i++) {
          String ss0=(String)HVariables.elementAt(i);
          String ss1=(String)HComments.elementAt(i);
            model0.addRow(
                   new Object[]{new String(ss0), new String(ss1) });
         }
          jSplitPane1.repaint();
      } // end function  









 
    
        // set variables from the file 
        public void SaveHistograms(boolean DoCheck)  {
        //DoCheck=true - check the settings
        //DoCheck=false - just save without checking  
   
        int hmax=jHTab1.getRowCount();
        int nn=0;
 
         for (int i=0;i<hmax;i++) {
            Object tmp1=jHTab1.getValueAt(i, 1);
            Object tmp2=jHTab1.getValueAt(i, 2);  
            Object tmp3=jHTab1.getValueAt(i, 3);
            Object tmp4=jHTab1.getValueAt(i, 4);
            Object tmp5=jHTab1.getValueAt(i, 5);
            Object tmp6=jHTab1.getValueAt(i, 6);
            Object tmp7=jHTab1.getValueAt(i, 7);
           
            if (tmp1 != null &&
                tmp2 != null &&
                tmp3 != null &&
                tmp4 != null  ) {
             //   System.out.println("Saving this histogram= "+(String)tmp1);
                SetIni.HistoName[nn]=(String)tmp1;
                SetIni.Histo2D[nn]=Utility.GetInt(tmp2.toString());
                SetIni.HistoMin[nn]=Utility.GetDouble(tmp3.toString());
                SetIni.HistoMax[nn]=Utility.GetDouble(tmp4.toString());
                SetIni.HistoBins[nn]=Utility.GetInt(tmp5.toString());
                SetIni.HistoWeight[nn]=Utility.GetDouble(tmp6.toString());
                SetIni.HistoComm[nn]=(String)tmp7;
                SetIni.HistoType[nn]=nn+1;
                nn++;
             }  
                }
       
     SetIni.HistoN=nn;
     if (nn == 0) SetIni.HistoN=0; 
   
    if (DoCheck) { // check  
   // make checks.........................     
    String ierr_mess="none";
    int ierr=0;
    
     // check histograms
    for  (int i=1; i<=SetIni.HistoN; i++ ) {
    if (SetIni.HistoType[i]  > 0 ) {
    if (SetIni.HistoMax[i] <=SetIni.HistoMin[i]) { 
    ierr=1; ierr_mess = "Histogram MIN value is \n larger than MAX value"; };
    if (SetIni.HistoBins[i]<=0) { ierr=1; ierr_mess = "Number of bins is wrong !"; };
    }; };
   
        
   // check histograms
// first 2
    if (SetIni.Histo2D[1] == 2 && SetIni.Histo2D[2] == 2) {
    for  (int i=1; i<=2; i++ ) {
    if  (SetIni.HistoMin[i] == 0 && SetIni.HistoMax[i] == 0 && SetIni.HistoBins[i] == 0) {
    ierr=1; ierr_mess = "Error in 2D histogram definition (No 1)"; }; }; };
// second  2
    if (SetIni.Histo2D[3] == 2 && SetIni.Histo2D[4] == 2) {
    for  (int i=3; i<=4; i++ ) {
    if  (SetIni.HistoMin[i] == 0 && SetIni.HistoMax[i] == 0 && SetIni.HistoBins[i] == 0) {
     ierr=1; ierr_mess = "Error in 2D histogram definition (No 2)"; }; }; };
// third  2
    if (SetIni.Histo2D[5] == 2 && SetIni.Histo2D[6] == 2) {
    for  (int i=5; i<=6; i++ ) {
    if  (SetIni.HistoMin[i] == 0 && SetIni.HistoMax[i] == 0 && SetIni.HistoBins[i] == 0) {
     ierr=1; ierr_mess = "Error in 2D histogram definition (No 3)"; }; }; };
// forth  2
    if (SetIni.Histo2D[7] == 2 && SetIni.Histo2D[8] == 2) {
    for  (int i=7; i<=8; i++ ) {
    if  (SetIni.HistoMin[i] == 0 && SetIni.HistoMax[i] == 0 && SetIni.HistoBins[i] == 0) {
     ierr=1; ierr_mess = "Error in 2D histogram definition (No 4)"; }; }; };

// show error message    
        if (ierr>0) {  
        JOptionPane dialog2 = new JOptionPane();
        dialog2.showMessageDialog(dialog2, ierr_mess,
        "Error", JOptionPane.ERROR_MESSAGE ); } 
   } // of of the check   
    
    
    
   } // end save histograms
 
    
        
  // set variables from the file 
        public void LoadHistograms()  {
           
        //int hmax=jHTab1.getRowCount();
         //System.out.println(SetIni.HistoN);
          
         for (int i=0;i<SetIni.HistoN;i++) {

          model.addRow(new Object[]{new Integer(i+1),
                                    new String(SetIni.HistoName[i]),
                                    new Integer(SetIni.Histo2D[i]),
                                    new Double(SetIni.HistoMin[i]),
                                    new Double(SetIni.HistoMax[i]),
                                    new Integer(SetIni.HistoBins[i]),
                                    new Double(SetIni.HistoWeight[i]),
                                    new String(" "+SetIni.HistoComm[i]) });

            // jHTab1.fireTableRowsInserted;
            // System.out.println(SetIni.HistoComm[i]);  
         }  
               
          jScrollPane2.revalidate();
          jScrollPane2.repaint(); 
         
        }
          
        

   

   /**
     * Removes item from the table.
     */
    public void removeSelected()
    {
            int selectedMin=jHTab1.getSelectedRow();
            int selectedN=jHTab1.getSelectedRowCount();
            int selectedMax=selectedMin+selectedN;
            int totalCounts=model.getRowCount();
            int ntot=0;
            // System.out.println(selectedMin+ " " + selectedMax+ " "+totalCounts);

            Object tmp1,tmp2,tmp3,tmp4,tmp5,tmp6,tmp7,tmp8;
            for (int i=0;i<totalCounts; i++) {
            tmp1=jHTab1.getValueAt(i, 1);
            tmp2=jHTab1.getValueAt(i, 2);
            tmp3=jHTab1.getValueAt(i, 3);
            tmp4=jHTab1.getValueAt(i, 4);
            tmp5=jHTab1.getValueAt(i, 5);
            tmp6=jHTab1.getValueAt(i, 6);
            tmp7=jHTab1.getValueAt(i, 7);
             if (i>=selectedMin && i<selectedMax) {
             //  model.removeRow(i);
             } else {
              ntot++;
              model.addRow(new Object[]{new Integer(ntot),tmp1,tmp2,tmp3,tmp4,tmp5,tmp6,tmp7});
             }

           };

             //   examples
             //   model.removeRow(0);
             //   model.removeRow(model.getRowCount()-1);
             // removeLast(jTab1.getSelectedRowCount());
                removeFirst(totalCounts-1);

    }


/**
     *  Copy item from the table.
     */
    public void copySelected()
    {
            int selectedMin=jHTab1.getSelectedRow();
            int selectedN=jHTab1.getSelectedRowCount();
            int selectedMax=selectedMin+selectedN;
            int totalCounts=model.getRowCount();
            int ntot=0;
            // System.out.println(selectedMin+ " " + selectedMax+ " "+totalCounts);

            H1.clear();
            H2.clear();
            H3.clear();
            H4.clear();
            H5.clear();
            H6.clear();
            H7.clear();

            Object tmp1,tmp2,tmp3,tmp4,tmp5,tmp6,tmp7;
            for (int i=selectedMin;i<selectedMax; i++) {
            tmp1=jHTab1.getValueAt(i, 1);
            tmp2=jHTab1.getValueAt(i, 2);
            tmp3=jHTab1.getValueAt(i, 3);
            tmp4=jHTab1.getValueAt(i, 4);
            tmp5=jHTab1.getValueAt(i, 5);
            tmp6=jHTab1.getValueAt(i, 6);
            tmp7=jHTab1.getValueAt(i, 7);

            H1.addElement( tmp1 );
            H2.addElement( tmp2 );
            H3.addElement( tmp3 );
            H4.addElement( tmp4 );
            H5.addElement( tmp5 );
            H6.addElement( tmp6 );
            H7.addElement( tmp7 );
 
//            System.out.println(tmp1); 
          };

         jHTab1.clearSelection();

    }


/**
     *  Paste item from the table.
     */
    public void pasteSelected()
    {
            int selectedMin=jHTab1.getSelectedRow();
            int selectedN=jHTab1.getSelectedRowCount();
            int selectedMax=selectedMin+selectedN;
            int totalCounts=model.getRowCount();
            int ntot;


        H1a.clear();
        H2a.clear();
        H3a.clear();
        H4a.clear();
        H5a.clear();
        H6a.clear();
        H7a.clear();

// get all elements first 
            Object tmp1,tmp2,tmp3,tmp4,tmp5,tmp6,tmp7;
            for (int i=0;i<totalCounts; i++) {
            tmp1=jHTab1.getValueAt(i, 1);
            tmp2=jHTab1.getValueAt(i, 2);
            tmp3=jHTab1.getValueAt(i, 3);
            tmp4=jHTab1.getValueAt(i, 4);
            tmp5=jHTab1.getValueAt(i, 5);
            tmp6=jHTab1.getValueAt(i, 6);
            tmp7=jHTab1.getValueAt(i, 7);
            H1a.addElement( tmp1 );
            H2a.addElement( tmp2 );
            H3a.addElement( tmp3 );
            H4a.addElement( tmp4 );
            H5a.addElement( tmp5 );
            H6a.addElement( tmp6 );
            H7a.addElement( tmp7 );
          };
   
   //    System.out.println(totalCounts);


            ntot=  PointerRow+1;
// inserts selected elements 
           for (int i=0;i<H1.size(); i++) {
            tmp1=H1.elementAt(i);
            tmp2=H2.elementAt(i);
            tmp3=H3.elementAt(i);
            tmp4=H4.elementAt(i);
            tmp5=H5.elementAt(i);
            tmp6=H6.elementAt(i);
            tmp7=H7.elementAt(i);

          if (ntot<=H1a.size() ) {
           H1a.insertElementAt(tmp1, ntot); 
           H2a.insertElementAt(tmp2, ntot); 
           H3a.insertElementAt(tmp3, ntot); 
           H4a.insertElementAt(tmp4, ntot); 
           H5a.insertElementAt(tmp5, ntot); 
           H6a.insertElementAt(tmp6, ntot); 
           H7a.insertElementAt(tmp7, ntot); 
           ntot++;
         }
          }

        //  System.out.println(H1a.size());

// clear table
            model.setRowCount(0);

            ntot=0;
            for (int i=0;i<H1a.size(); i++) {
            ntot++;
            tmp1=H1a.elementAt(i);
            tmp2=H2a.elementAt(i);
            tmp3=H3a.elementAt(i);
            tmp4=H4a.elementAt(i);
            tmp5=H5a.elementAt(i);
            tmp6=H6a.elementAt(i);
            tmp7=H7a.elementAt(i);
            model.addRow(new Object[]{new Integer(ntot),tmp1,tmp2,tmp3,tmp4,tmp5,tmp6,tmp7});
          };

          
          jHTab1.clearSelection();


    }











 
          
 /**
     * Removes all items from the table.
     */
    public void removeAll()
    {
        while(model.getRowCount() > 0)
            model.removeRow(0);
    }


    /**
     * Removes first Nmin entries.
     */

    public void removeFirst(int Nmin)
    {
        for (int i=0;i<=Nmin; i++) model.removeRow(0);

     //  while(model.getRowCount()>model.getRowCount()-Nmin)
      //      model.removeRow(model.getRowCount(0));
    }

// store message 
     private void setMessage()  {
          SetIni.ShowHistoN=Integer.toString(SetIni.HistoN)+" histograms";
     } 
          
          
} // end class






 // change defaults for JList
class HistoCellRenderer
 extends  JLabel
 implements ListCellRenderer 
{

 public static final long serialVersionUID = 11;

 private ImageIcon image[];
  
 final static ImageIcon longIcon = new ImageIcon("long.gif");
 final static ImageIcon shortIcon = new ImageIcon("short.gif");
  
 

 public HistoCellRenderer()
 {
  setOpaque(true);

 
  /*
  // Pre-load the graphics images to save time
  image = new ImageIcon[4];
  image[0] = new ImageIcon( "circles.gif" );
  image[1] = new ImageIcon( "bubbles.gif" );
  image[2] = new ImageIcon( "thatch.gif" );
  image[3] = new ImageIcon( "pinstripe.gif" );
 
 */
 }
  
  
 public Component getListCellRendererComponent(
   JList list, Object value, int index, 
   boolean isSelected, boolean cellHasFocus )
   
 
 {
  // Display the text for this item
  
   
   
  String s = value.toString();
         setText(s);
         setIcon((s.length() > 10) ? longIcon : shortIcon);
  
  
  // Draw the correct colors and font
  if( isSelected )
  {
   // Set the color and font for a selected item
   setBackground( Color.blue );
   setForeground( Color.white );
   setFont( new Font( "Lucida Sans", Font.BOLD, 14 ) );
  }
  else
  {
   // Set the color and font for an unselected item
   setBackground( Color.white );
   setForeground( Color.black );
   setFont( new Font( "Lucida Sans", Font.BOLD, 14 ) );
  }

  return this;
 }




}

