// * This code is licensed under:
// * JSlovo License, Version 1.0
// * - for license details see http://jslovo.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

package JRunMC.ui;

import JRunMC.util.*;

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import java.util.logging.*;
import java.net.URL;

import javax.help.*;


public class  HelpRunMC extends JDialog{


   public static final long serialVersionUID =  115;

   public HelpRunMC() {

    try {

   setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
   setTitle("RunMC Help");
   setModal( false );
   setResizable( true );
 // Get the system resolution
   Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
   Dimension size = new Dimension(Math.min(700, res.width), Math.min(600, res.height));
   setSize(size);



      URL url = ResourceLoader.getResourceURL( "#help/html/MyHelp.hs");
      HelpSet hs = new HelpSet(null, url);
      HelpBroker hb = hs.createHelpBroker();
      JHelp helpViewer = new JHelp(hs);
    //  helpViewer.setCurrentID("Contents");
    //   hb.enableHelpKey(Global.mainFrame.getRootPane(), "overview", hs);        // for F1



      this.getContentPane().add(helpViewer);


    }
    catch (Exception e) {
      e.printStackTrace();
    }


   // set visible and put on center
     setVisible();

   }

// create about
   public void setVisible() {
// store mainframe dimensions
    Dimension dim = Global.mainFrame.getSize();
    int w=dim.width;
    int h=dim.height;
 // Get the system resolution
    Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
    Dimension size = new Dimension(Math.min( (int)(1.1*w),res.width),
                        Math.min((int)(1.2*h), res.height) );
    this.setSize(size);

// show with some shift to the rigth 
    Util.rightShiftWithin( Global.mainFrame, this );

    this.setVisible(true); 
   }


}
