C
C
      INTEGER FUNCTION IPDGQU(K,IDBAM)
C**********************************************************************
C
C     quark contents according to PDG conventions
C     (random selection in case of quark mixing)
C
C     input:   IDBAM  BAMJET particle code
C              K      1..3   quark number
C
C     output:  1   d  (anti --> neg.)
C              2   u
C              3   s
C              4   c
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      IQ = IBAMQU(K,IDBAM,0)
C  quark-antiquark
      IF((IQ.GT.6).AND.(IQ.LT.13)) THEN
        IQ = 6 - IQ
      ENDIF
C  exchange of up and down
      IF(ABS(IQ).EQ.1) THEN
        IQ = SIGN(2,IQ)
      ELSE IF(ABS(IQ).EQ.2) THEN
        IQ = SIGN(1,IQ)
      ENDIF
      IPDGQU = IQ
      END
