C
C
       DOUBLE PRECISION FUNCTION PLBEK0(X)
C**********************************************************************
C
C      Modified Bessel Function K0
C
C**********************************************************************
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)       
C
       IF (X .LT. 2.D0) THEN
         Y = X**2/4.D0
         PLBEK0 =
     &     (-LOG(X/2.D0)*PLBEI0(X))+(-.57721566D0+Y*(0.42278420D0
     &     +Y*(0.23069756D0+Y*(0.3488590D-1+Y*(0.262698D-2
     &     +Y*(0.10750D-3+Y*0.740D-5))))))
       ELSE
         Y = 2.D0/X
         PLBEK0 =
     &     (EXP(-X)/SQRT(X))*(1.25331414D0+Y*(-0.7832358D-1
     &     +Y*(0.2189568D-1+Y*(-0.1062446D-1+Y*(0.587872D-2
     &     +Y*(-0.251540D-2+Y*0.53208D-3))))))
       ENDIF
       END
